include:
  - project: algebananazzzzz/gitlabtemplates
    ref: main
    file:
      - Rules/env-trigger-rule.yml
      - Jobs/terraform-jobs.yml
      - Jobs/golang-jobs.yml
      - Vars/aws-vars.yml

variables:
  ENV:
    value: "prd"
  WORKSPACE:
    value: "prd-webapp"
  extends: .aws-vars:all

stages:
  - "build"
  - "test"
  - "deploy"

go-build:
  stage: build
  script:
    - cd src/
    - GOOS=linux GOARCH=amd64 go build -tags lambda.norpc -o ../build/bootstrap .
  extends:
    - .golang:image
    - .golang:cache
    - .trigger-rule-auto
  artifacts:
    when: on_success
    expire_in: "1 days"
    paths:
      - "build/bootstrap"

terraform-plan:
  stage: test
  extends:
    - .trigger-rule-auto
    - .terraform:image
    - .terraform:plan
    - .terraform:cache

terraform-apply:
  stage: deploy
  dependencies:
    - "terraform-plan"
  extends:
    - .trigger-rule-manual:prd
    - .terraform:image
    - .terraform:apply
    - .terraform:cache
